#!/usr/bin/env python
#
# pyLOM - Python Low Order Modeling.
#
# IO Module
#
# Last rev: 20/10/2021

# Pickle and HDF5 exchange format
from .io_pkl  import pkl_load, pkl_save
from .io_h5   import h5_load_dset, h5_save_dset, h5_append_dset, h5_save_mesh, h5_load_mesh, h5_save_POD, h5_load_POD, h5_save_DMD, h5_load_DMD, h5_save_SPOD, h5_load_SPOD, h5_save_VAE

# VTK HDF5 3D format
from .io_vtkh5 import vtkh5_save_mesh, vtkh5_link_mesh, vtkh5_save_field

# Ensight 3D format
from .io_ensight import Ensight_readCase, Ensight_readCase2, Ensight_writeCase, Ensight_readGeo, Ensight_readGeo2, Ensight_writeGeo, Ensight_readField, Ensight_readField2, Ensight_writeField

# Output to paraview
from .io_paraview import pv_writer

del io_pkl, io_h5, io_ensight, io_paraview
